rm -f *.cat

cat <<EOF > pgm.awk
BEGIN { FS=":" }
{
    string = ""
    n = length(\$4)

    lower_flag = 0
    for (i = 1; i <= n; i++) {

	ch = substr(\$4, i, 1)

	if (lower_flag)
	    ch = tolower(ch)

	string = string ch

	if (ch != " " && ch != ".")
	    lower_flag = 1
	else
	    lower_flag = 0
    }
    print string ":" \$2 ":" \$3 ":" \$1
}
EOF

cat <<EOF > pgm1.awk
BEGIN { FS=":" }
{
    print \$1 ":" \$2 ":" \$3 ":" NR ":" \$4
}
EOF

echo "1:advance.txt" > catalog.ca2
grep -n "^\*" advance.txt |sed "/[2-9]$/d;/:\*END/d" | wc -l > advance.ca1
grep -n "^\*" advance.txt |sed "/[2-9]$/d;/:\*END/d;s/\(.*\):\*\(.*\)/\2:1:\1:\2:/;s/^THE //"|nawk -f pgm.awk|sort|nawk -f pgm1.awk >> advance.ca1

sed "\
s/Mapmaking/MapMaking/;\
s/Superconductor/SuperConductor/;\
" advance.ca1 > advance.cat

echo "2:improvem.txt" >> catalog.ca2
echo "3:wonders.txt" >> catalog.ca2
cat improvem.txt wonders.txt|grep -n "^\*" |sed "/[2-9]$/d;/:\*END/d" | wc -l > improvem.ca1
grep -n "^\*" improvem.txt|sed "/[2-9]$/d;/:\*END/d;s/\(.*\):\*\(.*\)/\2:2:\1:\2:/;s/^THE //">improvem.ca2
grep -n "^\*" wonders.txt |sed "/[2-9]$/d;/:\*END/d;s/\(.*\):\*\(.*\)/\2:3:\1:\2:/;s/^THE //">>improvem.ca2
nawk -f pgm.awk improvem.ca2|sort|nawk -f pgm1.awk >> improvem.ca1

sed "\
s/Marketplace/MarketPlace/;\
s/Sdi Defense/SDI Defense/;\
s/Ss Component/SS Component/;\
s/Ss Module/SS Module/;\
s/Ss Structural/SS Structural/;\
s/Seti Program/SETI Program/;\
" improvem.ca1 > improvem.cat

echo "4:units.txt" >> catalog.ca2
grep -n "^\*" units.txt   |sed "/[2-9]$/d;/:\*END/d" | wc -l > units.cat
grep -n "^\*" units.txt   |sed "/[2-9]$/d;/:\*END/d;s/\(.*\):\*\(.*\)/\2:4:\1:\2:/;s/^THE //"|nawk -f pgm.awk|sort|nawk -f pgm1.awk >> units.cat

echo "5:terrain.txt" >> catalog.ca2
grep -n "^\*" terrain.txt |sed "/[2-9]$/d;/:\*END/d" | wc -l > terrain.cat
grep -n "^\*" terrain.txt |sed "/[2-9]$/d;/:\*END/d;s/\(.*\):\*\(.*\)/\2:5:\1:\2:/;s/^THE //"|nawk -f pgm.awk|sort|nawk -f pgm1.awk >> terrain.cat


echo "6:miscella.txt" >> catalog.ca2
grep -n "^\*" miscella.txt|sed "/[2-9]$/d;/:\*END/d" | wc -l > miscella.cat
grep -n "^\*" miscella.txt|sed "/[2-9]$/d;/:\*END/d;s/\(.*\):\*\(.*\)/\2:6:\1:\2:/;s/^THE //"|nawk -f pgm.awk|sort|nawk -f pgm1.awk >> miscella.cat

cat *.cat | sort | tail +7 | wc -l > complete.ca2
cat *.cat | sort | tail +7 >> complete.ca2
mv catalog.ca2 catalog.cat
mv complete.ca2 complete.cat

grep -n "^\*" wonders.txt |sed "/[2-9]$/d;/:\*END/d" | wc -l > wonders.ca1
grep -n "^\*" wonders.txt |sed "/[2-9]$/d;/:\*END/d;s/\(.*\):\*\(.*\)/\2:3:\1:\2:/;s/^THE //"|nawk -f pgm.awk|sort|nawk -f pgm1.awk >> wonders.ca1
sed "s/Seti Program/SETI Program/" wonders.ca1 > wonders.cat

rm pgm.awk pgm1.awk
rm -f *.ca1 *.ca2
